<template>
	<table class="min-w-full">
		<thead>
			<slot name="columns">
				<tr>
					<table-header>#</table-header>
					<table-header v-for="({ name }, index) in columns" :key="index">
						{{ name }}
					</table-header>
					<table-header v-if="actions.length != 0">Действия</table-header>
				</tr>
			</slot>
		</thead>
		<tbody>
			<tr v-for="(item, index) in data">
				<slot :row="item">
					<table-cell>{{ index + 1 }}</table-cell>
					<table-cell v-for="({ key }, tdIndex) in columns" :key="`column-${tdIndex}`">
						{{ item[key] }} 
					</table-cell>
					<table-cell>
						<div v-for="({ className, label, emit, actionKey, icon}, 
							actionIndex ) in actions" 
							:key="`action-${actionIndex}`"
						>
							<button
								:class="className"
								@click="$emit(emit,{ id: item[actionKey] })"
							>
								<icon class="float-left mr-1 mt-1" v-if="icon" :icon="icon" size="16" />{{ label }}
							</button>
						</div>
					</table-cell>
				</slot>
			</tr>
		</tbody>
	</table>
</template>

<script>
export default {
	name: 'CompTable',
	props: {
		data: {
			type: Array,
			default: () => []
		},
		columns: {
			type: Array,
			default: () => []
		},
		actions: {
			type: Array,
			default: () => []
		}
	},
	components: {
		//Для стилизации названия столбцов
		TableHeader: () => import('./components/TableHeader'),
		//Для стилизации ячеек таблицы
		TableCell: () => import('./components/TableCell'),
	},
}
</script>

